Bug 612198 - RFE: add mod_reqtimeout to mitigate against slowloris attack
RFE: add mod_reqtimeout to mitigate against slowloris attack
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: httpd (Show other bugs)
5.5
All Linux
medium Severity medium
: rc
: ---
Assigned To: Joe Orton
BaseOS QE Security Team
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-07 10:23 EDT by john.haxby@oracle.com
Modified: 2011-11-21 21:49 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
: 676634 (view as bug list)
Environment:
Last Closed: 2011-07-21 04:54:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to backport mod_reqtimeout (59.14 KB, patch)
2010-07-07 10:23 EDT, john.haxby@oracle.com
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:1067 normal SHIPPED_LIVE httpd bug fix and enhancement update 2011-07-21 04:51:15 EDT

  None (edit)
Description john.haxby@oracle.com 2010-07-07 10:23:47 EDT
Created attachment 430079 [details]
Patch to backport mod_reqtimeout

Description of problem:

The slowloris attack seems to be gaining popularity and there is a real need to mitigate against this type of attack in httpd.  The RHEL httpd is susceptible to a slowloris attack and there is little that can be done to prevent it.



Version-Release number of selected component (if applicable): httpd-2.2.3-43


How reproducible:  Always


Steps to Reproduce:
1. Download slowloris
2. Follow the instructions
   (I don't really want to post detailed instructions here, but they
    are available if you want them.)
  
Actual results:
  It is embarrassingly easy to completely snarl up an httpd server.


Expected results:
  httpd continues to work properly

Additional info:
  The attached patch backports mod_reqtimeout from httpd 2.2.15.  The bulk of
  of the changes are just to roll in documentation and the module itself ports
  without any trouble at all.  Once you have this then you can this in, say,
  /etc/httpd/conf.d/reqtimeout.conf:

    LoadModule reqtimeout_module modules/mod_reqtimeout.so
    RequestReadTimeout header=10 body=30

  The actual parameters might need tweaking for some environments, but having
  this did completely stop slowloris on my test machine.
Comment 1 RHEL Product and Program Management 2010-10-05 15:17:15 EDT
This request was evaluated by Red Hat Product Management for
inclusion in the current release of Red Hat Enterprise Linux.
Because the affected component is not scheduled to be updated in the
current release, Red Hat is unfortunately unable to address this
request at this time. Red Hat invites you to ask your support
representative to propose this request, if appropriate and relevant,
in the next release of Red Hat Enterprise Linux.
Comment 2 Denise Dumas 2010-10-05 16:19:03 EDT
^#%$@ bugbot - fixing flags ...
Comment 3 Joe Orton 2010-10-07 07:40:34 EDT
See bug 508238 for discussion of "slowloris" and how to mitigate this type of attack.

mod_reqtimeout in current 2.2.x releases had some significant bugs; there is a significant improvement in the version slated for inclusion in 2.2.17 though currently lacking review upstream.
Comment 9 errata-xmlrpc 2011-07-21 04:54:05 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-1067.html
Comment 10 errata-xmlrpc 2011-07-21 07:47:06 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-1067.html

Note You need to log in before you can comment on or make changes to this bug.